;*******************************************************************************
; C_startup for R8C/Tiny
;******************************************************************************

;---------------------------------------------------------------
; 	Arrangement of section
;---------------------------------------------------------------
; Near RAM data area
;---------------------------------------------------------------
; SBDATA area
	.section	data_SE,DATA
	.org	ram_top
data_SE_top:

	.section	bss_SE,DATA,ALIGN
bss_SE_top:

	.section	data_SO,DATA
data_SO_top:

	.section	bss_SO,DATA
bss_SO_top:

; near RAM area
	.section	data_NE,DATA,ALIGN
data_NE_top:

	.section	bss_NE,DATA,ALIGN
bss_NE_top:

	.section	data_NO,DATA
data_NO_top:

	.section	bss_NO,DATA
bss_NO_top:

	.section	ram,DATA

;---------------------------------------------------------------
; Near ROM data area
;---------------------------------------------------------------
	.section	rom_NE,ROMDATA
	.org		rom_top
rom_NE_top:

	.section	rom_NO,ROMDATA
rom_NO_top:

;---------------------------------------------------------------
; Initial data of 'data' section
;---------------------------------------------------------------
	.section	data_SEI,ROMDATA,ALIGN
data_SEI_top:

	.section	data_SOI,ROMDATA
data_SOI_top:

	.section	data_NEI,ROMDATA,ALIGN
data_NEI_top:
 
	.section	data_NOI,ROMDATA
data_NOI_top:

;---------------------------------------------------------------
; Switch Table Section
;---------------------------------------------------------------
	.section        switch_table,ROMDATA
switch_table_top:

;---------------------------------------------------------------
; code area
;---------------------------------------------------------------

	.section	program,CODE,ALIGN

	.section	interrupt,CODE,ALIGN

;---------------------------------------------------------------
; variable vector section
;---------------------------------------------------------------
	.section	vector,ROMDATA	; variable vector table
	.org	VECTOR_ADR

	.glb	_tx_int

	.lword	dummy_int		; 0 BRK
	.lword	dummy_int		; 1 
	.lword	dummy_int		; 2 
	.lword	dummy_int		; 3 
	.lword	dummy_int		; 4 
	.lword	dummy_int		; 5 
	.lword	dummy_int		; 6 
	.lword	dummy_int		; 7 
	.lword	dummy_int		; 8 
	.lword	dummy_int		; 9 
	.lword	dummy_int		;10 
	.lword	dummy_int		;11 
	.lword	dummy_int		;12 
	.lword	dummy_int		;13 KeyInput
	.lword	dummy_int		;14 A-D
	.lword	dummy_int		;15 
	.lword	dummy_int		;16 TimerC Compair1
	.lword	dummy_int		;17 UART0 Tx
	.lword	dummy_int		;18 UART0 Rx
	.lword	dummy_int		;19 UART1 Tx
	.lword	dummy_int		;20 UART1 Rx
	.lword	dummy_int		;21 INT2
	.lword	_tx_int			;22 TimerX
	.lword	dummy_int		;23 TimerY
	.lword	dummy_int		;24 TimerZ
	.lword	dummy_int		;25 INT1
	.lword	dummy_int		;26 INT3
	.lword	dummy_int		;27 TimerC
	.lword	dummy_int		;28 TimerC Compair0
	.lword	dummy_int		;29 INT0
	.lword	dummy_int		;30 
	.lword	dummy_int		;31 
	.lword	dummy_int		; vector 32
	.lword	dummy_int		; vector 33
	.lword	dummy_int		; vector 34
	.lword	dummy_int		; vector 35
	.lword	dummy_int		; vector 36
	.lword	dummy_int		; vector 37
	.lword	dummy_int		; vector 38
	.lword	dummy_int		; vector 39
	.lword	dummy_int		; vector 40
	.lword	dummy_int		; vector 41
	.lword	dummy_int		; vector 42
	.lword	dummy_int		; vector 43
	.lword	dummy_int		; vector 44
	.lword	dummy_int		; vector 45
	.lword	dummy_int		; vector 46
	.lword	dummy_int		; vector 47
	.lword	dummy_int		; vector 48
	.lword	dummy_int		; vector 49
	.lword	dummy_int		; vector 50
	.lword	dummy_int		; vector 51
	.lword	dummy_int		; vector 52
	.lword	dummy_int		; vector 53
	.lword	dummy_int		; vector 54

;	.lword	dummy_int		; vector 55
;	.lword	dummy_int		; vector 56
;	.lword	dummy_int		; vector 57
;	.lword	dummy_int		; vector 58
;	.lword	dummy_int		; vector 59
;	.lword	dummy_int		; vector 60
;	.lword	dummy_int		; vector 61
;	.lword	dummy_int		; vector 62
;	.lword	dummy_int		; vector 63

;===============================================================
; fixed vector section
;---------------------------------------------------------------
	.section	fvector,ROMDATA		; fixed vector table
	.org	FVECTOR_ADR
	.LWORD	dummy_int	; FFFDC`F Undefined instruction
	.LWORD	dummy_int	; FFFE0`3 Overflow
	.LWORD	dummy_int	; FFFE4`7 BRK instruction
	.LWORD	dummy_int	; FFFE8`B Address match
	.LWORD	dummy_int	; FFFEC`F Single step
	.LWORD	dummy_int	; FFFF0`3 Watchdog timer
	.LWORD	dummy_int	; FFFF4`7 
	.LWORD	dummy_int	; FFFF8`B 
RESET:
	.LWORD	start + 0FF000000h

;****************************************************************************

